#pragma once

#include "math.h"
#include "stdlib.h"
#include "MyFiles.h"
#include "surface.h"
#include "Input.h"


class GameObject
{


public:
	GameObject(); // this is the default
	
	GameObject(Surface* a_Image); // uses an existing image

	
// this routine needs to do a bit more work than setting up a few variables so its code will live in the cpp file.	
	GameObject(char* filename, MyFiles* filehander); // creates an image from the 

	
//desctructor needs to do cleaning up	
	~GameObject();


	virtual bool Update(Surface* s, Input* InputHandler);
	
	
	static  int NumberOfObjectsCreated; // everytime we make an object we'll increase this value, and store the value in the OBID

	int OBJID; // its useful sometimes to identify an object by a value, every object will have its own unique ID numbver from 0 to XXXXXX
	
	float	Xpos, Ypos; // all objects need this
	float	Xspeed, Yspeed;
	bool	onscreen;		// we might want to mark an object as off screen to avoid processing
	bool	MarkForRemoval; // once out game decides this object is not needed we can mark it for removal so a clean up routine can get rid of it

	Surface* Image; // this is the image we will display
	

	


};
