#include "../Headers/MapManager.h"

MapManager::MapManager()
{
}


MapManager::~MapManager()
{
	//delete the map
	if (TheMap.size() != 0)
	{
		printf("A map still exists and is now being erased\n");
		
		for (int y = 0; y = TheMap.size(); y++)
			TheMap[y].clear(); // clear each of the elements
		
		TheMap.clear(); // now clear the main body
		
	}
	
}


bool MapManager::LoadMap(char* fn, int xs , int ys)
{
	fn = (char*)"faultysimplemap.csv";
	
	// does our vector of vectors already have data, if so we need to clear it
	if (TheMap.size() != 0)
	{
		printf("A map already exists and is now being erased\n");
		for(int y = 0 ; y < TheMap.size()  ; y++)
			TheMap[y].clear(); // clear each of the elements
		
		TheMap.clear(); // no clear the main body
	}
		
	printf("Mapsize is set to %i\n", TheMap.size());
		
	if (xs == 0 || ys == 0)
	{
		printf("Map has a 0 value which is not allowed\n");
		return false;
	}
	
	std::ifstream t(fn); // open an input stream for our file

// now load each value in turn store them into our vector make our vectors;
		for (int y = 0; y < ys; y++)
		{
			std::vector<int> T; // a vector for the columns 
			std::string Line; // a temp string for the line
			std::getline(t, Line); // get a whole line and put it in Lione
			
			if (Line.empty()) break; // check if its done, in case we misjudged it
			std::stringstream Ln(Line); // make this into a stream
		
			TheMap.push_back(T);
			
			for (int x = 0; x < xs; x++) // pull the columns along
			{
				std::string val;
				std::getline(Ln, val,',');
				if (val.empty()) break; // if not enough values break the inner loop
				
 // only do this in debug
				int view = stoi(val);	
				printf("%2i,", view);
				// store the int of the string
				TheMap[y].push_back(stoi(val));
			}
			printf("<\n");
	
		}
	printf("Mapsize is Y-%i : X-%i \n\n", TheMap.size(), TheMap[0].size());
	t.close();	
}






	
	

	
